#!/bin/sh
PN="adobeillustrator-cs2"
VERSION="12.0"
RELEASE="1"
PRIORITY="0"
ADVICE=""
TYPE="restrict"
# all downloads should not have any traling parameters like ?downlaodid=1234 .....(should rewrite in python)
ICON="http://icons.iconarchive.com/icons/deleket/adobe-family/256/Adobe-Illustrator-CS2-icon.png"
X86="http://internal.graz.disconnected-by-peer.at/Orig/Adobe/Illustrator/12.0/Adobe-Illustrator-CS2-disk1.iso"
#AMD64="http://downloads.sourceforge.net/sevenzip/7z920-x64.msi"
ICONFILE=${ICON##*/}
X86FILE=${X86##*/}
#AMD64FILE=${AMD64##*/}

	if [ -e /var/tmp/opsi/upload/$TYPE/${PN}_${VERSION}-${RELEASE}.opsi ]
	then
		echo "package ${PN}_${VERSION}-${RELEASE}.opsi already generated"
		exit 1
	fi

OUT=$(mktemp -d /tmp/output.XXXXXXXXXX) || { echo "Failed to create temp dir"; exit 1; }
mkdir $OUT/$PN
cp -Rv OPSI CLIENT_DATA $OUT/$PN
unix2dos $OUT/$PN/CLIENT_DATA/*

	if [ -e /usr/portage/distfiles/$ICONFILE ]
	then
		if [ -e $ICONFILE.sha1sum ]
		then
			SHA1SUM=`cat $ICONFILE.sha1sum`
			CHECKSUM=`sha1sum /usr/portage/distfiles/$ICONFILE`
			if [ "$CHECKSUM" = "$SHA1SUM" ]
			then
				convert -colorspace rgb /usr/portage/distfiles/$ICONFILE -transparent white -background transparent -resize 160x160\> \
					-size 160x160 xc:transparent +swap -gravity center -composite $OUT/$PN/CLIENT_DATA/$PN.png
			else
				echo "The checksums do not match."
				exit 1
			fi
		else
			echo "You need to create the checksums with: sha1sum /usr/portage/distfiles/$ICONFILE > $ICONFILE.sha1sum"
			exit 1
		fi
	else
		echo "Downloading file"
		wget -P /usr/portage/distfiles/ $ICON
		exit 1
	fi

	if [ -e /usr/portage/distfiles/$X86FILE ]
	then
		if [ -e $X86FILE.sha1sum ]
		then
			SHA1SUM=`cat $X86FILE.sha1sum`
			CHECKSUM=`sha1sum /usr/portage/distfiles/$X86FILE`
			if [ "$CHECKSUM" = "$SHA1SUM" ]
			then
				#cp /usr/portage/distfiles/$X86FILE $OUT/$PN/CLIENT_DATA
				mkdir -p $OUT/$PN/CLIENT_DATA/files
				7z x -o$OUT/$PN/CLIENT_DATA/files /usr/portage/distfiles/$X86FILE
			else
				echo "The checksums do not match."
				exit 1
			fi
		else
			echo "You need to create the checksums with: sha1sum /usr/portage/distfiles/$X86FILE > $X86FILE.sha1sum"
			exit 1
		fi
	else
		echo "Downloading file"
		#wget -O /usr/portage/distfiles/$X86FILE $X86
		plowdown -o /usr/portage/distfiles $X86
		exit 1
	fi

#	if [ -e /usr/portage/distfiles/$AMD64FILE ]
#	then
#		if [ -e $AMD64FILE.sha1sum ]
#		then
#			SHA1SUM=`cat $AMD64FILE.sha1sum`
#			CHECKSUM=`sha1sum /usr/portage/distfiles/$AMD64FILE`
#			if [ "$CHECKSUM" = "$SHA1SUM" ]
#			then
#				cp /usr/portage/distfiles/$AMD64FILE $OUT/$PN/CLIENT_DATA
#			else
#				echo "The checksums do not match." 
#				exit 1
#			fi
#		else
#			echo "You need to create the checksums with: sha1sum /usr/portage/distfiles/$AMD64FILE > $AMD64FILE.sha1sum"
#			exit 1
#		fi
#	else
#		echo "Downloading file"
#		wget -P /usr/portage/distfiles/ $AMD64
#		exit 1
#	fi

sed -e "s!VERSION!$VERSION!g" -e "s!RELEASE!$RELEASE!g" -e "s!PRIORITY!$PRIORITY!g" -e "s!ADVICE!$ADVICE!g" -i $OUT/$PN/OPSI/control
#sed -e "s!X86FILE!$X86FILE!g" -e "s!AMD64FILE!$AMD64FILE!g" -i $OUT/$PN/CLIENT_DATA/setup.ins
sed -e "s!X86FILE!$X86FILE!g" -i $OUT/$PN/CLIENT_DATA/setup32.ins

if test -d ".git"; then
    git log --date-order --date=short | \
    sed -e '/^commit.*$/d' | \
    awk '/^Author/ {sub(/\\$/,""); getline t; print $0 t; next}; 1' | \
    sed -e 's/^Author: //g' | \
    sed -e 's/>Date:   \([0-9]*-[0-9]*-[0-9]*\)/>\t\1/g' | \
    sed -e 's/^\(.*\) \(\)\t\(.*\)/\3    \1    \2/g' > $OUT/$PN/OPSI/changelog.txt
else
    echo "No git repository present."
    exit 1
fi

pushd $OUT
opsi-makeproductfile -v $OUT/$PN
popd

mkdir -p /var/tmp/opsi/upload/$TYPE/
cp -afv $OUT/*.opsi /var/tmp/opsi/upload/$TYPE/

#rm -rf $OUT

